#include <stdio.h>
#include <string.h>

int main(int argc, char *argv[])
{
    char sndout_dll[260], avs_in_file[260], avs_out_file[260], sndout_cmd[260];
    FILE *in, *out;
    char buf[1024];
    int first, done;
    char *p;

    if (argc != 5) {
        printf("Syntax: generate_sndout.c sndout_dll out_avs in_avs sndout_cmd\n");
        return 0;
    }

    strcpy(sndout_dll, argv[1]);
    strcpy(avs_out_file, argv[2]);
    strcpy(avs_in_file, argv[3]);
    strcpy(sndout_cmd, argv[4]);

    in = fopen(avs_in_file, "rt");
    if (in == NULL) {
        printf("Can't open in_file %s\n", avs_in_file);
        return 0;
    }
    out = fopen(avs_out_file, "wt");
    if (out == NULL) {
        fclose(in);
        printf("Can't open out_file %s\n", avs_in_file);
        return 0;
    }
    first = 1;
    done = 0;
    while (1) {
        if (fgets(buf, 1024, in) == NULL) break;
        if (first) {
            first = 0;
            fprintf(out, "LoadPlugin(\"%s\")\n", sndout_dll);
        }
        p = buf;
        while (*p == ' ' || *p == '\t') p++;
        if (strnicmp(p, "return", 6) == 0) {
            fprintf(out, "SoundOut(%s)\n\n", sndout_cmd);
            fprintf(out, "%s", buf);
            done = 1;
            break;
        }
        fprintf(out, "%s", buf);
    }
    if (done == 0)
        fprintf(out, "SoundOut(%s)\n\n", sndout_cmd);
    fclose(in);
    fclose(out);
    return 0;
}
